﻿using System;

namespace AutofacDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            AutofacUsage autofac = new AutofacUsage();
            autofac.RegisterInstance1();

            autofac.RegisterInstance2();

            autofac.RegisterInstance3();

            autofac.RegisterTypeNoneParameterConstructor();

            autofac.RegisterTypeIncludeOneParameterConstructor1();

            autofac.RegisterTypeIncludeOneParameterConstructor2();

            autofac.RegisterTypeIncludeOneParameterConstructor3();

            autofac.RegisterTypeIncludeTwoParametersConstructor();

            autofac.RegisterTypeCommon1();
            autofac.RegisterTypeCommon3();

            autofac.RegisterAssembly();

            //如果要读取xml，注意在app.config中配置runtime节点
            autofac.RegisterModule();

            //上述方式都不是最常用的，最常用的方式是这个xml configuration
            autofac.RegisterModuleByXML1();
            
            //这个混合了xml configuration和code注册2种在一起
            autofac.RegisterModuleByXML2();
            Console.ReadLine();
        }
    }
}
